import { NonterminalKind } from '@nomicfoundation/slang/kinds/index.js';
import { getNodeMetadata } from '../slang-utils/metadata.js';
import { Identifier } from './Identifier.js';
export class ABICoderPragma {
    constructor(ast, offset) {
        this.kind = NonterminalKind.ABICoderPragma;
        const metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.version = new Identifier(ast.version, offsets[0]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return ['abicoder ', path.call(print, 'version')];
    }
}
//# sourceMappingURL=ABICoderPragma.js.map