import { NonterminalKind } from '@nomicfoundation/slang/kinds/index.js';
import { getNodeMetadata } from '../slang-utils/metadata.js';
export class SimpleVersionLiteral {
    constructor(ast, offset) {
        this.kind = NonterminalKind.SimpleVersionLiteral;
        const metadata = getNodeMetadata(ast, offset, true);
        this.items = ast.items.map((item) => item.text);
        this.separators = ast.separators.map((separator) => separator.text);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print() {
        return this.items.map((item, index) => index === 0 ? item : [this.separators[index - 1], item]);
    }
}
//# sourceMappingURL=SimpleVersionLiteral.js.map