import { TerminalNode } from '@nomicfoundation/slang/cst/index.js';
import { NonterminalKind } from '@nomicfoundation/slang/kinds/index.js';
import { getNodeMetadata, updateMetadata } from '../slang-utils/metadata.js';
import { SimpleVersionLiteral } from './SimpleVersionLiteral.js';
export class VersionLiteral {
    constructor(ast, offset) {
        this.kind = NonterminalKind.VersionLiteral;
        let metadata = getNodeMetadata(ast, offset);
        const { offsets } = metadata;
        this.variant =
            ast.variant instanceof TerminalNode
                ? ast.variant.text
                : new SimpleVersionLiteral(ast.variant, offsets[0]);
        metadata = updateMetadata(metadata, typeof this.variant === 'string' ? [] : [this.variant]);
        this.comments = metadata.comments;
        this.loc = metadata.loc;
    }
    print(path, print) {
        return typeof this.variant === 'string'
            ? this.variant
            : path.call(print, 'variant');
    }
}
//# sourceMappingURL=VersionLiteral.js.map